      program main
      parameter (nx=40,ny=40)
      dimension x(nx,ny),y(nx,ny),u(nx,ny),ex(nx,ny),ey(nx,ny)
      dimension zc(7)
      character*80 fname
c
      x1=5.0
      y1=0.0
      x2=-5.0
      y2=0.0
c
      do 10 j=1,ny
         do 10 i=1,nx
            x(i,j) = float(i-1)*0.5-9.75
            y(i,j) = float(j-1)*0.5-9.75
            r1=sqrt((x(i,j)-x1)*(x(i,j)-x1)+(y(i,j)-y1)*(y(i,j)-y1))
            r2=sqrt((x(i,j)-x2)*(x(i,j)-x2)+(y(i,j)-y2)*(y(i,j)-y2))
            if ((r1.eq.0).or.(r2.eq.0)) goto 10
            u(i,j)= 1.0/r1 + 1.0/r2
 10   continue
c
      do 20 j=2,ny-1
         do 20 i=2,nx-1
            ex(i,j)=(u(i+1,j)-u(i-1,j))/(x(i+1,j)-x(i-1,j))
            ey(i,j)=(u(i,j+1)-u(i,j-1))/(y(i,j+1)-y(i,j-1))
 20   continue
c
c     --- I/O unit number 
      nd=10 
c
c     --- number of contour lines
      nc=15
c
c     --- resolution for contour fill 
      ires=300
      jres=300 
c
c     --- grid lines
      fname='grid'
      call ngrida(nd,fname,nx,ny,x,y)
c     --- frame line
      fname='frame'
      call ngfrma(nd,fname,nx,ny,x,y)
c
c     --- arithmetric sequecial levels (auto setting)
c
      fname='u1_col'
      call ngcc1a(nd,fname,nx,ny,x,y,u,nc)
      fname='u1_mono'
      call ngcm1a(nd,fname,nx,ny,x,y,u,nc)
      fname='u1_fill'
      call ngcf1a(nd,fname,nx,ny,x,y,u,nc,ires,jres)
c
c     --- geometric sequencial levels (auto setting)
c
      fname='u2_col'
      call ngcc2a(nd,fname,nx,ny,x,y,u,nc)
      fname='u2_mono'
      call ngcm2a(nd,fname,nx,ny,x,y,u,nc)
      fname='u2_fill'
      call ngcf2a(nd,fname,nx,ny,x,y,u,nc,ires,jres)
c
c     - arithimetric sequencial levels (manual setting)
c                z = zmin + dz*(n-1)
      zmin=0.2
      dz=0.2
      fname='u3_col'
      call ngcc3a(nd,fname,nx,ny,x,y,u,nc,zmin,dz)
      fname='u3_mono'
      call ngcm3a(nd,fname,nx,ny,x,y,u,nc,zmin,dz)
      fname='u3_fill'
      call ngcf3a(nd,fname,nx,ny,x,y,u,nc,zmin,dz,ires,jres)
c
c     - geometric sequencial levels (manual setting) 
c               z = zmac*ratio**(n-1)   
      zmax=3.0
      ratio=0.8
      fname='u4_col'
      call ngcc4a(nd,fname,nx,ny,x,y,u,nc,zmax,ratio)
      fname='u4_mono'
      call ngcm4a(nd,fname,nx,ny,x,y,u,nc,zmax,ratio)
      fname='u4_fill'
      call ngcf4a(nd,fname,nx,ny,x,y,u,nc,zmax,ratio,ires,jres)
c
c     - table data level setting
c               z = zc(n) 
      zc(1)=0.1
      zc(2)=0.2
      zc(3)=0.3
      zc(4)=0.5
      zc(5)=1.0
      zc(6)=2.5
      zc(7)=3.0
      nc2=7
      fname='u5_col'
      call ngcc5a(nd,fname,nx,ny,x,y,u,nc2,zc)
      fname='u5_mono'
      call ngcm5a(nd,fname,nx,ny,x,y,u,nc2,zc)
      fname='u5_fill'
      call ngcf5a(nd,fname,nx,ny,x,y,u,nc2,zc,ires,jres)
c
      stop
      end
