      program main
      parameter (nx=41,ny=41)
      dimension x(nx,ny),y(nx,ny),u(nx,ny),zc(7)
      integer msk(nx,ny)
      character*80 fname
c
      x1=5.0
      y1=0.0
      x2=-5.0
      y2=0.0
c
      do 10 j=1,ny
         do 10 i=1,nx
            x(i,j)=float(i-21)*0.5
            y(i,j)=float(j-21)*0.5
            r1=sqrt((x(i,j)-x1)*(x(i,j)-x1)+(y(i,j)-y1)*(y(i,j)-y1))
            r2=sqrt((x(i,j)-x2)*(x(i,j)-x2)+(y(i,j)-y2)*(y(i,j)-y2))
            if ((r1.eq.0.0).or.(r2.eq.0.0)) then
               u(i,j)=0.0
               msk(i,j)=1
            else
               u(i,j)= 1.0/r1 + 1.0/r2
               msk(i,j)=0
            endif
 10   continue
c
c     --- I/O unit number 
      nd=10
c
c     --- number of contour lines
      nc=15
c
c     --- draw area 
      i1 = 1
      j1 = 1
      i2 = nx
      j2 = ny
c
      ires=300
      jres=300
c
      fname='frame_all'
      call ngfrma(nd,fname,nx,ny,x,y)
      fname='frame'
      call ngfrms(nd,fname,nx,ny,x,y,i1,j1,i2,j2,msk)
c
      fname='grid'
      call ngrids(nd,fname,nx,ny,x,y,i1,j1,i2,j2,msk)
c
c
c     --- arithmetric sequecial levels (auto setting)
c
      fname='u1_col'
      call ngcc1s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk)
      fname='u1_mono'
      call ngcm1s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk)
      fname='u1_fill'
      call ngcf1s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk,ires,jres)
c
c     --- geometric sequencial levels (auto setting)
c
      fname='u2_col'
      call ngcc2s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk)
      fname='u2_mono'
      call ngcm2s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk)
      fname='u2_fill'
      call ngcf2s(nd,fname,nx,ny,x,y,u,nc,i1,j1,i2,j2,msk,ires,jres)
c
c     - arithimetric sequencial levels (manual setting)
c                z = zmin + dz*(n-1)
      zmin=0.2
      dz=0.2
      fname='u3_col'
      call ngcc3s(nd,fname,nx,ny,x,y,u,nc,zmin,dz,i1,j1,i2,j2,msk)
      fname='u3_mono'
      call ngcm3s(nd,fname,nx,ny,x,y,u,nc,zmin,dz,i1,j1,i2,j2,msk)
      fname='u3_fill'
      call ngcf3s(nd,fname,nx,ny,x,y,u,nc,zmin,dz,i1,j1,i2,j2,msk,
     &     ires,jres)
c
c     - geometric sequencial levels (manual setting) 
c               z = zmac*ratio**(n-1)   
      zmax=3.0
      ratio=0.8
      fname='u4_col'
      call ngcc4s(nd,fname,nx,ny,x,y,u,nc,zmax,ratio,i1,j1,i2,j2,msk)
      fname='u4_mono'
      call ngcm4s(nd,fname,nx,ny,x,y,u,nc,zmax,ratio,i1,j1,i2,j2,msk)
      fname='u4_fill'
      call ngcf4s(nd,fname,nx,ny,x,y,u,nc,zmax,ratio,i1,j1,i2,j2,msk,
     &     ires,jres)
c
c     - table data level setting
c               z = zc(n) 
      zc(1)=0.1
      zc(2)=0.2
      zc(3)=0.3
      zc(4)=0.5
      zc(5)=1.0
      zc(6)=2.5
      zc(7)=3.0
      nc2=7
      fname='u5_col'
      call ngcc5s(nd,fname,nx,ny,x,y,u,nc2,zc,i1,j1,i2,j2,msk)
      fname='u5_mono'
      call ngcm5s(nd,fname,nx,ny,x,y,u,nc2,zc,i1,j1,i2,j2,msk)
      fname='u5_fill'
      call ngcf5s(nd,fname,nx,ny,x,y,u,nc2,zc,i1,j1,i2,j2,msk,ires,jres)
c
      stop
      end



