      program main
      parameter (nx=61,ny=61)
      dimension x(nx,ny),y(nx,ny),psi(nx,ny),u(nx,ny),v(nx,ny),
     &     phi(nx,ny),umag(nx,ny),uc(10)
      integer nmsk(nx,ny)
      character*80 fname
c
c     --- array data 
      do 10 j=1,ny
         do 10 i=1,nx
            x(i,j)=-3.0+float(i-1)/10.0
            y(i,j)=-3.0+float(j-1)/10.0
            psi(i,j)=x(i,j)*y(i,j)
            phi(i,j)=-0.5*(x(i,j)*x(i,j)-y(i,j)*y(i,j))
            u(i,j)=-x(i,j)
            v(i,j)=y(i,j)
            umag(i,j)=sqrt(u(i,j)*u(i,j)+v(i,j)*v(i,j))
 10   continue
c
c     --- I/O unit number 
      nd=10 
c
c     ---- frame of domain
      fname='frame'
      call ngfrma(nd,fname,nx,ny,x,y)
c
c     ---- grids
      fname='grid'
      call ngrida(nd,fname,nx,ny,x,y)
c
c     ---- contour lines without colors
      fname='phi_mono'
      call ngcm1a(nd,fname,nx,ny,x,y,phi,10)
      fname='phi_col'
      call ngcc1a(nd,fname,nx,ny,x,y,phi,10)
      fname='psi'
      call ngcm1a(nd,fname,nx,ny,x,y,psi,10)
c
c     ---- fac   : factor of arrow length
c     ---- ref   : reference arrow size ( legend )
c     ---- id,jd : skip steps
c 
      fac=0.1
      ref=4.0
      id=3
      jd=3
      nc=10
c
c     --- monochrome arrows
      fname='velocity_mono'
      call ngama(nd,fname,nx,ny,x,y,u,v,fac,ref,id,jd)
c
c     --- color arrows ( color level : umag ) 
      fname='velocity1'
      call ngac1a(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc)
      fname='velocity2'
      call ngac2a(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc)
      umin=0.0
      du=1.0
      nc=6
      fname='velocity3'
      call ngac3a(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,umin,du)
c
      umax=4.2
      ratio=0.6
      nc=6
      fname='velocity4'
      call ngac4a(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,
     &     umax,ratio)
c
      fname='velocity5'
      uc(1)=0.0
      uc(2)=0.5
      uc(3)=1.0
      uc(4)=2.0
      uc(5)=3.0
      uc(6)=4.0
      uc(7)=5.0
      nc=7
      call ngac5a(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,uc)
c
      stop
      end
