      program main
      parameter (nx=61,ny=61)
      dimension x(nx,ny),y(nx,ny),psi(nx,ny),u(nx,ny),v(nx,ny),
     &     phi(nx,ny),umag(nx,ny),uc(10)
      integer msk(nx,ny)
      character*80 fname
c
c     --- array data 
      do 10 j=1,ny
         do 10 i=1,nx
            x(i,j)=-3.0+float(i-1)/10.0
            y(i,j)=-3.0+float(j-1)/10.0
            psi(i,j)=x(i,j)*y(i,j)
            phi(i,j)=-0.5*(x(i,j)*x(i,j)-y(i,j)*y(i,j))
            u(i,j)=-x(i,j)
            v(i,j)=y(i,j)
            umag(i,j)=sqrt(u(i,j)*u(i,j)+v(i,j)*v(i,j))
            msk(i,j)=0
 10   continue
c
      i1=5
      j1=5
      i2=nx-4
      j2=ny-4
      msk(7,7)=1
      msk(40,40)=1
      msk(41,40)=1
      msk(42,40)=1
c     --- I/O unit number 
      nd=10 
c
c     ---- frame of domain
      fname='frame'
      call ngfrms(nd,fname,nx,ny,x,y,i1,j1,i2,j2,msk)
c
c     ---- grids
      fname='grid'
      call ngrids(nd,fname,nx,ny,x,y,i1,j1,i2,j2,msk)
c
c     ---- contour lines
      fname='phi'
      call ngcm1s(nd,fname,nx,ny,x,y,phi,10,i1,j1,i2,j2,msk)
      fname='psi'
      call ngcm1a(nd,fname,nx,ny,x,y,psi,10,i1,j1,i2,j2,msk)
c
c     ---- fac   : factor of arrow length
c     ---- ref   : reference arrow size ( legend )
c     ---- id,jd : skip steps
c 
      fac=0.1
      ref=4.0
      id=2
      jd=2
      i1=6
      j1=6
      nc=10
c
c     --- monochrome arrows
      fname='velocity_mono'
      call ngams(nd,fname,nx,ny,x,y,u,v,fac,ref,id,jd,i1,j1,i2,j2,msk)
c
c     --- color arrows ( color level : umag ) 
      fname='velocity1'
      call ngac1s(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,
     &     i1,j1,i2,j2,msk)
      fname='velocity2'
      call ngac2s(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,
     &     i1,j1,i2,j2,msk)
      umin=0.0
      du=1.0
      nc=6
      fname='velocity3'
      call ngac3s(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,umin,du,
     &     i1,i1,i2,j2,msk)
c
      umax=4.2
      ratio=0.6
      nc=7
      fname='velocity4'
      call ngac4s(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,
     &     umax,ratio,i1,j1,i2,j2,msk)
c
      fname='velocity5'
      uc(1)=0.0
      uc(2)=0.5
      uc(3)=1.0
      uc(4)=2.0
      uc(5)=3.0
      uc(6)=4.0
      uc(7)=5.0
      nc=7
      call ngac5s(nd,fname,nx,ny,x,y,u,v,umag,fac,ref,id,jd,nc,uc,
     &     i1,j1,i2,j2,msk)
c
      stop
      end
